Attribute VB_Name = "Mod_General"
Public Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Public Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Public Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long

Global DIR_WINDOWS  As String
Global DIR_SYSTEM   As String
Global DIR_TEMP     As String
Global DIR_APP      As String

Global KEYS_REM     As Integer
Global KEYS_BKU     As Integer

Public Const ARMADILLO_EXL As String = "" & vbCrLf & "MERIT" & vbCrLf & _
                                        "SORTORDERINDEX" & vbCrLf & "VERSION" & vbCrLf & _
                                        "WMSDKMERIT" & vbCrLf & "ID" & vbCrLf & _
                                        "OLEDB_SERVICES" & vbCrLf & "TOI" & vbCrLf & _
                                        "TSD" & vbCrLf & "EDITFLAGS" & vbCrLf & _
                                        "APPID" & vbCrLf & "INFOTIP" & vbCrLf & _
                                        "MENUTEXTPUI" & "FLAGS" & vbCrLf & _
                                        "LOCALIZEDSTRING" & vbCrLf & "MENUTEXT" & vbCrLf & _
                                        "HELPTEXT" & vbCrLf & "THREADINGMODEL" & vbCrLf & _
                                        "INPROCSERVER32" & vbCrLf & "SEED" & vbCrLf & _
                                        "NEVERSHOWEXT" & vbCrLf & "DEFAULTICON" & vbCrLf & _
                                        "MASTERVERSION" & vbCrLf & "DETAILS" & vbCrLf & _
                                        "INTROTEXT" & vbCrLf & "PAGETITLE" & vbCrLf & _
                                        "FRIENDLYTYPENAME" & vbCrLf & "LOCALSERVICE" & vbCrLf & _
                                        "NOOPEN" & vbCrLf & "{305CA226-D286-468e-B848-2B2E8E697B74} 2" & vbCrLf & _
                                        "COLLECTIONCLSID"

Public Const PACKERS_EVA As String = ";EVACleaner v2.7 packer configuration file" & vbCrLf & _
                                        ";" & vbCrLf & _
                                        ";Syntax :" & vbCrLf & _
                                        ";" & vbCrLf & _
                                        ";HKEY_CLASSES_ROOT  : HKCR" & vbCrLf & _
                                        ";HKEY_LOCAL_MACHINE : HKLM" & vbCrLf & _
                                        ";HKEY_CURRENT_USER  : HKCU" & vbCrLf & _
                                        ";" & vbCrLf & _
                                        ";Example : For HKEY_LOCAL_MACHINE\CLSID, write :" & vbCrLf & _
                                        ";HKLM\CLSID" & vbCrLf & _
                                        ";" & vbCrLf & _
                                        ";Do NOT enter the '\' character at the end of the path" & vbCrLf & _
                                        ";RIGHT : HKLM\CLSID" & vbCrLf & _
                                        ";WRONG : HKLM\CLSID\" & vbCrLf & _
                                        ";" & vbCrLf & _
                                        ";Enjoy, BLiND PRoPHET" & vbCrLf & _
                                        "" & vbCrLf & _
                                        ";Standard Path(s)" & vbCrLf & _
                                        "HKCR\CLSID"
                                        
Public SEARCH_ARMADILLO()   As String
Public SEARCH_ASPROTECT()   As String
Public SEARCH_OBSIDIUM()    As String
Public EXL_ARMADILLO()      As String
                                        
Public Function ExistDirectory(ByVal ThePath As String) As Boolean
ExistDirectory = IIf(ThePath > "", Dir(ThePath, vbDirectory) > "", False)
End Function

Public Function ExistFile(ByVal ThePath As String) As Boolean
ExistFile = IIf(ThePath > "", Dir$(ThePath) > "", False)
End Function
Public Sub GetDirectories()
Dim TmpStr As String * 255
Dim TmpLng As Long

TmpLng = GetWindowsDirectory(TmpStr, Len(TmpStr))
DIR_WINDOWS = Left$(TmpStr, TmpLng)

TmpLng = GetSystemDirectory(TmpStr, Len(TmpStr))
DIR_SYSTEM = Left$(TmpStr, TmpLng)

TmpLng = GetTempPath(Len(TmpStr), TmpStr)
DIR_TEMP = Left$(TmpStr, TmpLng)

DIR_APP = App.Path

If Right$(DIR_WINDOWS, 1) <> "\" Then DIR_WINDOWS = DIR_WINDOWS & "\"
If Right$(DIR_SYSTEM, 1) <> "\" Then DIR_SYSTEM = DIR_SYSTEM & "\"
If Right$(DIR_TEMP, 1) <> "\" Then DIR_TEMP = DIR_TEMP & "\"
If Right$(DIR_APP, 1) <> "\" Then DIR_APP = DIR_APP & "\"
End Sub

Public Sub CheckConfigDirectories()
'check if the \config directory exists
If ExistDirectory(DIR_APP & "config") = False Then
    MsgBox "CONFIG Directory was not found. It will now be created...", vbExclamation, "No \config Directory"
    'if not, then create it and create the files needed.
    MkDir DIR_APP & "config"
    'create the Armadillo Exlude File
    Open DIR_APP & "config\Armadillo.exl" For Output As #1
        Print #1, ARMADILLO_EXL;
    Close
    'create the Armadillo Search File
    Open DIR_APP & "config\Armadillo.eva" For Output As #1
        Print #1, PACKERS_EVA
    Close
    'create the ASProtect Search File
    Open DIR_APP & "config\ASProtect.eva" For Output As #1
        Print #1, PACKERS_EVA
    Close
    'create the Obsidium Search File
    Open DIR_APP & "config\Obsidium.eva" For Output As #1
        Print #1, PACKERS_EVA
    Close
Else
    'check for Armadillo.eva file
    If ExistFile(DIR_APP & "config\Armadillo.eva") = False Then
        MsgBox "Armadillo.eva file was not found. A new file will be created with the" & vbCrLf & _
                "default search locations.", vbExclamation, "Armadillo.eva Not Found"
        
        Open DIR_APP & "config\Armadillo.eva" For Output As #1
            Print #1, PACKERS_EVA
        Close
    End If
    
    'check for ASProtect.eva file
    If ExistFile(DIR_APP & "config\ASProtect.eva") = False Then
        MsgBox "ASProtect.eva file was not found. A new file will be created with the" & vbCrLf & _
                "default search locations.", vbExclamation, "ASProtect.eva Not Found"
        
        Open DIR_APP & "config\ASProtect.eva" For Output As #1
            Print #1, PACKERS_EVA
        Close
    End If
    
    'check for Obsidium.eva file
    If ExistFile(DIR_APP & "config\Obsidium.eva") = False Then
        MsgBox "Obsidium.eva file was not found. A new file will be created with the" & vbCrLf & _
                "default search locations.", vbExclamation, "Obsidium.eva Not Found"
        
        Open DIR_APP & "config\Obsidium.eva" For Output As #1
            Print #1, PACKERS_EVA
        Close
    End If
    
    If ExistFile(DIR_APP & "config\Armadillo.exl") = False Then
        MsgBox "Armadillo.exl file was not found. A new file will be created with the" & vbCrLf & _
                "default exclude names.", vbExclamation, "Armadillo.exl Not Found"
        
        Open DIR_APP & "config\Armadillo.exl" For Output As #1
            Print #1, ARMADILLO_EXL;
        Close
    End If
End If
End Sub

Public Sub LoadFile_EVA(ByVal InputFile As String, ByRef OutputArray() As String)
On Error Resume Next
Dim ReadLine As String

Erase OutputArray()
ReDim OutputArray(0) As String

Close
Open InputFile For Input As #1
    Do Until EOF(1)
        DoEvents
        Line Input #1, ReadLine
        
        If Left$(ReadLine, 1) <> ";" And Trim(ReadLine) <> "" Then
            ReDim Preserve OutputArray(UBound(OutputArray) + 1) As String
            OutputArray(UBound(OutputArray)) = ReadLine
        End If
    Loop
Close
End Sub
Public Sub LoadFile_EXL(ByVal InputFile As String, ByRef OutputArray() As String)
On Error Resume Next
Dim ReadLine As String

Erase OutputArray()
ReDim OutputArray(0) As String

Close
Open InputFile For Input As #1
    Do Until EOF(1)
        Line Input #1, ReadLine
    
        ReDim Preserve OutputArray(UBound(OutputArray) + 1) As String
        OutputArray(UBound(OutputArray)) = ReadLine
    Loop
Close
End Sub

Public Sub ShowProgress(ByVal TheText As String)
Main.StatusBar1.Panels(1).Text = "Status : " & TheText
End Sub

Public Sub AddToTree()
On Error Resume Next

Dim P_ACP As Boolean
Dim P_ARM As Boolean
Dim P_ASP As Boolean
Dim P_OBS As Boolean
Dim P_PCG As Boolean
Dim P_SVK As Boolean

Dim ACP_C As Integer
Dim ARM_C As Integer
Dim ASP_C As Integer
Dim OBS_C As Integer
Dim PCG_C As Integer
Dim SVK_C As Integer

If UBound(Evaluation_Information) > 0 Then
    
    P_ACP = False
    P_ARM = False
    P_ASP = False
    P_OBS = False
    P_PCG = False
    P_SVK = False
    
    ACP_C = 0
    ARM_C = 0
    ASP_C = 0
    OBS_C = 0
    PCG_C = 0
    SVK_C = 0
    
    For i = 1 To UBound(Evaluation_Information)
        DoEvents
        If Evaluation_Information(i).ThePacker = "ACProtect" Then
            If P_ACP = False Then
                Main.TreeView1.Nodes.Add , , "ACProtect", "ACProtect", 1, 1
                P_ACP = True
            End If
            
            Main.TreeView1.Nodes.Add "ACProtect", 4, , Evaluation_Information(i).ThePath, 12, 12
            
            ACP_C = ACP_C + 1
        
        ElseIf Evaluation_Information(i).ThePacker = "Armadillo" Then
            If P_ARM = False Then
                Main.TreeView1.Nodes.Add , , "Armadillo", "Armadillo", 2, 2
                P_ARM = True
            End If
            
            If Evaluation_Information(i).TheType = "Reg" Then
                Main.TreeView1.Nodes.Add "Armadillo", 4, , Evaluation_Information(i).ThePath, 13, 13
            Else
                Main.TreeView1.Nodes.Add "Armadillo", 4, , Evaluation_Information(i).ThePath, 12, 12
            End If
            
            ARM_C = ARM_C + 1
        
        ElseIf Evaluation_Information(i).ThePacker = "ASProtect" Then
            If P_ASP = False Then
                Main.TreeView1.Nodes.Add , , "ASProtect", "ASProtect", 3, 3
                P_ASP = True
            End If
            
            Main.TreeView1.Nodes.Add "ASProtect", 4, , Evaluation_Information(i).ThePath, 13, 13
            
            ASP_C = ASP_C + 1
        
        ElseIf Evaluation_Information(i).ThePacker = "Obsidium" Then
            If P_OBS = False Then
                Main.TreeView1.Nodes.Add , , "Obsidium", "Obsidium", 4, 4
                P_OBS = True
            End If
            
            If Evaluation_Information(i).TheType = "File" Then
                Main.TreeView1.Nodes.Add "Obsidium", 4, , Evaluation_Information(i).ThePath, 12, 12
            Else
                Main.TreeView1.Nodes.Add "Obsidium", 4, , Evaluation_Information(i).ThePath, 13, 13
            End If
            
            OBS_C = OBS_C + 1
        
        ElseIf Evaluation_Information(i).ThePacker = "PCGuard" Then
            If P_PCG = False Then
                Main.TreeView1.Nodes.Add , , "PCGuard", "PCGuard", 5, 5
                P_PCG = True
            End If
            
            If Evaluation_Information(i).TheType = "File" Then
                Main.TreeView1.Nodes.Add "PCGuard", 4, , Evaluation_Information(i).ThePath, 12, 12
            Else
                Main.TreeView1.Nodes.Add "PCGuard", 4, , Evaluation_Information(i).ThePath, 13, 13
            End If
            
            PCG_C = PCG_C + 1
            
        ElseIf Evaluation_Information(i).ThePacker = "SVK" Then
            If P_SVK = False Then
                Main.TreeView1.Nodes.Add , , "SVK", "SVK", 6, 6
                P_SVK = True
            End If
            
            Main.TreeView1.Nodes.Add "SVK", 4, , Evaluation_Information(i).ThePath, 12, 12
            
            SVK_C = SVK_C + 1
            
        End If
    Next i
    
    Main.Label7.Caption = IIf(ACP_C < 10, "0" & ACP_C, ACP_C)
    Main.Label8.Caption = IIf(ARM_C < 10, "0" & ARM_C, ARM_C)
    Main.Label9.Caption = IIf(ASP_C < 10, "0" & ASP_C, ASP_C)
    Main.Label10.Caption = IIf(OBS_C < 10, "0" & OBS_C, OBS_C)
    Main.Label11.Caption = IIf(PCG_C < 10, "0" & PCG_C, PCG_C)
    Main.Label12.Caption = IIf(SVK_C < 10, "0" & SVK_C, SVK_C)
End If
End Sub
Public Function IsText(ByVal TheText As String) As Boolean
IsText = True
For i = 1 To Len(TheText)
    DoEvents
    If Asc(Mid$(TheText, i, 1)) <= 33 Or Asc(Mid$(TheText, i, 1)) >= 126 Then
        IsText = False
        Exit For
    End If
Next i
End Function

Public Sub BackUpRegistry()
Dim TheCmd  As String
Dim ThePath As String
Dim MyChar  As String

For i = 1 To UBound(Evaluation_Information)
    DoEvents
    If Evaluation_Information(i).BackUp = "Yes" Then
        ThePath = ""
        For k = 1 To Len(Evaluation_Information(i).ThePath)
            DoEvents
            MyChar = IIf(Mid$(Evaluation_Information(i).ThePath, k, 1) = "\", "#", Mid$(Evaluation_Information(i).ThePath, k, 1))
            ThePath = ThePath & MyChar
        Next k
            
        TheCmd = "regedit /e " & Chr$(34) & DIR_APP & ThePath & ".reg" & Chr$(34) & Chr$(32) & Evaluation_Information(i).TheRoot & "\" & Evaluation_Information(i).ThePath
        Shell TheCmd, vbHide
    End If
Next i
End Sub

Public Sub ExecuteCommandLine(ByVal TheCommand As String)
Dim PROT_ACP As Boolean
Dim PROT_ASP As Boolean
Dim PROT_OBS As Boolean
Dim PROT_PCG As Boolean
Dim PROT_SVK As Boolean

Dim SILENT  As Boolean
Dim BckUp   As Boolean

If TheCommand = "" Then Exit Sub

PROT_ACP = IIf(InStr(1, TheCommand, "ACProtect", vbTextCompare) > 0, True, False)
PROT_ASP = IIf(InStr(1, TheCommand, "ASProtect", vbTextCompare) > 0, True, False)
PROT_OBS = IIf(InStr(1, TheCommand, "Obsidium", vbTextCompare) > 0, True, False)
PROT_PCG = IIf(InStr(1, TheCommand, "PCGuard", vbTextCompare) > 0, True, False)
PROT_SVK = IIf(InStr(1, TheCommand, "SVK", vbTextCompare) > 0, True, False)

SILENT = IIf(InStr(1, TheCommand, "Silent", vbTextCompare) > 0, True, False)
BckUp = IIf(InStr(1, TheCommand, "BackUp", vbTextCompare) > 0, True, False)

Erase Evaluation_Information()
ReDim Evaluation_Information(0) As Listing
If PROT_ACP = True Then Call Protector_ACProtect(PROTECTOR_SCAN)
If PROT_ASP = True Then Call Protector_ASProtect(PROTECTOR_SCAN)
If PROT_OBS = True Then Call Protector_Obsidium(PROTECTOR_SCAN)
If PROT_PCG = True Then Call Protector_PCGuard(PROTECTOR_SCAN)
If PROT_SVK = True Then Call Protector_SVK(PROTECTOR_SCAN)

For i = 1 To UBound(Evaluation_Information)
    DoEvents
    If BckUp = True Then Evaluation_Information(i).BackUp = "Yes"
    Evaluation_Information(i).ToClear = True
Next i

Call BackUpRegistry

If PROT_ACP = True Then Call Protector_ACProtect(PROTECTOR_REMOVE)
If PROT_ASP = True Then Call Protector_ASProtect(PROTECTOR_REMOVE)
If PROT_OBS = True Then Call Protector_Obsidium(PROTECTOR_REMOVE)
If PROT_PCG = True Then Call Protector_PCGuard(PROTECTOR_REMOVE)
If PROT_SVK = True Then Call Protector_SVK(PROTECTOR_REMOVE)

Erase Evaluation_Information()

If SILENT = False Then MsgBox "Trial Information Successfully removed!", vbInformation, "EVACleaner"

End
End Sub
