Attribute VB_Name = "Mod_Protectors"
Public Enum WhatToDo
    PROTECTOR_SCAN
    PROTECTOR_REMOVE
End Enum

Public Enum Packers
    ACProtect
    Armadillo
    ASProtect
    Obsidium
    PCGuard
    SVK
End Enum

Public Type Listing
    ThePacker   As String
    TheType     As String
    TheRoot     As String
    ThePath     As String
    ToClear     As Boolean
    ArmValue    As String
    BackUp      As String
End Type

Public AllKeys()                As String
Public Evaluation_Information() As Listing
Public AS_EnumKeys()            As String

Global ASProtect_FLAG   As Boolean
Global ASProtect_VERS   As Boolean
Global ARM_FLAG         As Boolean

Public Sub Protector_ACProtect(ByVal Action As WhatToDo)
On Error Resume Next

If Action = PROTECTOR_SCAN Then
    Dim TheFiles As String
    
    ShowProgress "Scanning ACProtect"
    TheFiles = Dir$(Left$(DIR_WINDOWS, 3) & "*.*", vbHidden)
    Do Until Len(TheFiles) = 0
        DoEvents
        ShowProgress "Scanning ... " & TheFiles
        
        If (Len(TheFiles) = 10) And (FileLen(Left$(DIR_WINDOWS, 3) & TheFiles) = 10) Then
            AddFoundKey "ACProtect", "File", "", Left$(DIR_WINDOWS, 3) & TheFiles
        End If
        
        TheFiles = Dir
    Loop
    ShowProgress "Idle"
ElseIf Action = PROTECTOR_REMOVE Then
    For i = 1 To UBound(Evaluation_Information)
        DoEvents
        If Evaluation_Information(i).ThePacker = "ACProtect" Then
            If Evaluation_Information(i).ToClear = True Then
                SetAttr Evaluation_Information(i).ThePath, vbNormal
                Kill Evaluation_Information(i).ThePath
            End If
        End If
    Next i
End If
End Sub
Public Sub Protector_Armadillo(ByVal Action As WhatToDo)
On Error Resume Next

If Action = PROTECTOR_SCAN Then
    Dim TheFiles As String
    
    ARM_FLAG = False
    
    ShowProgress "Scanning Armadillo"
    For i = 1 To UBound(SEARCH_ARMADILLO)
        DoEvents
        
        Erase AllKeys()
        ReDim AllKeys(0) As String
        
        ShowProgress "Scanning " & SEARCH_ARMADILLO(i)
        Select Case Left$(SEARCH_ARMADILLO(i), 4)
            Case Is = "HKCR"
                EnumKeys HKEY_CLASSES_ROOT, Mid$(SEARCH_ARMADILLO(i), 6)
                ExtractValidKeys HKEY_CLASSES_ROOT, Armadillo, Mid$(SEARCH_ARMADILLO(i), 6)
            Case Is = "HKLM"
                EnumKeys HKEY_LOCAL_MACHINE, Mid$(SEARCH_ARMADILLO(i), 6)
                ExtractValidKeys HKEY_LOCAL_MACHINE, Armadillo, Mid$(SEARCH_ARMADILLO(i), 6)
            Case Is = "HKCU"
                EnumKeys HKEY_CURRENT_USER, Mid$(SEARCH_ARMADILLO(i), 6)
                ExtractValidKeys HKEY_CURRENT_USER, Armadillo, Mid$(SEARCH_ARMADILLO(i), 6)
        End Select
        
        TheFiles = Dir$(DIR_TEMP & "*.tmp")
        Do Until Len(TheFiles) = 0
            DoEvents
            ShowProgress "Scanning ... " & TheFiles
            
            If (Left$(TheFiles, 1) <> "~") And (Len(TheFiles) = 12) Then
                AddFoundKey "Armadillo", "File", "", DIR_TEMP & TheFiles
            End If
            TheFiles = Dir
        Loop
    Next i
    
    ShowProgress "Idle"
ElseIf Action = PROTECTOR_REMOVE Then
    DeleteKey HKEY_CURRENT_USER, "SOFTWARE\The Silicon Realms Toolworks\Armadillo"
    DeleteKey HKEY_LOCAL_MACHINE, "SOFTWARE\The Silicon Realms Toolworks\Armadillo"
    DeleteKey HKEY_LOCAL_MACHINE, "SOFTWARE\Licenses"
    
    For i = 1 To UBound(Evaluation_Information)
        DoEvents
        If Evaluation_Information(i).ThePacker = "Armadillo" Then
            If Evaluation_Information(i).ToClear = True Then
                If Evaluation_Information(i).TheType = "Reg" Then
                    If Evaluation_Information(i).ArmValue <> "" Then
                        If Evaluation_Information(i).TheRoot = "HKEY_CLASSES_ROOT" Then
                            DeleteValue HKEY_CLASSES_ROOT, Evaluation_Information(i).ThePath, Evaluation_Information(i).ArmValue
                        ElseIf Evaluation_Information(i).TheRoot = "HKEY_LOCAL_MACHINE" Then
                            DeleteValue HKEY_LOCAL_MACHINE, Evaluation_Information(i).ThePath, Evaluation_Information(i).ArmValue
                        ElseIf Evaluation_Information(i).TheRoot = "HKEY_CURRENT_USER" Then
                            DeleteValue HKEY_CURRENT_USER, Evaluation_Information(i).ThePath, Evaluation_Information(i).ArmValue
                        End If
                    End If
                ElseIf Evaluation_Information(i).TheType = "File" Then
                    SetAttr Evaluation_Information(i).ThePath, vbNormal
                    Kill Evaluation_Information(i).ThePath
                End If
            End If
        End If
    Next i
End If
End Sub
Public Sub Protector_ASProtect(ByVal Action As WhatToDo)
On Error Resume Next

If Action = PROTECTOR_SCAN Then
    ASProtect_FLAG = False
    
    ShowProgress "Scanning ASProtect"
    For i = 1 To UBound(SEARCH_ASPROTECT)
        DoEvents
        
        Erase AllKeys()
        ReDim AllKeys(0) As String
        
        ShowProgress "Scanning " & SEARCH_ASPROTECT(i)
        Select Case Left$(SEARCH_ASPROTECT(i), 4)
            Case Is = "HKCR"
                EnumKeys HKEY_CLASSES_ROOT, Mid$(SEARCH_ASPROTECT(i), 6)
                ExtractValidKeys HKEY_CLASSES_ROOT, ASProtect, Mid$(SEARCH_ASPROTECT(i), 6)
            Case Is = "HKCU"
                EnumKeys HKEY_CURRENT_USER, Mid$(SEARCH_ASPROTECT(i), 6)
                ExtractValidKeys HKEY_CURRENT_USER, ASProtect, Mid$(SEARCH_ASPROTECT(i), 6)
            Case Is = "HKLM"
                EnumKeys HKEY_LOCAL_MACHINE, Mid$(SEARCH_ASPROTECT(i), 6)
                ExtractValidKeys HKEY_LOCAL_MACHINE, ASProtect, Mid$(SEARCH_ASPROTECT(i), 6)
        End Select
    Next i
    
    ShowProgress "Idle"
    Erase AllKeys()
    ASProtect_FLAG = False
ElseIf Action = PROTECTOR_REMOVE Then
    DeleteKey HKEY_CURRENT_USER, "SOFTWARE\ASProtect\Data"
    DeleteKey HKEY_CURRENT_USER, "SOFTWARE\ASProtect\SpecData"
    
    For i = 1 To UBound(Evaluation_Information)
        DoEvents
        If Evaluation_Information(i).ThePacker = "ASProtect" Then
            If Evaluation_Information(i).ToClear = True Then
                Erase AllKeys()
                ReDim AllKeys(0) As String
                
                If Evaluation_Information(i).TheRoot = "HKEY_CLASSES_ROOT" Then
                    EnumAllRegKeys HKEY_CLASSES_ROOT, Evaluation_Information(i).ThePath
                    For j = 1 To 3
                        DoEvents
                        For k = 1 To UBound(AllKeys)
                            DoEvents
                            DeleteKey HKEY_CLASSES_ROOT, AllKeys(k)
                        Next k
                    Next j
                    
                    DeleteKey HKEY_CLASSES_ROOT, Evaluation_Information(i).ThePath
                ElseIf Evaluation_Information(i).TheRoot = "HKEY_CURRENT_USER" Then
                    EnumAllRegKeys HKEY_CURRENT_USER, Evaluation_Information(i).ThePath
                    For j = 1 To 3
                        DoEvents
                        For k = 1 To UBound(AllKeys)
                            DoEvents
                            DeleteKey HKEY_CURRENT_USER, AllKeys(k)
                        Next k
                    Next j
                    
                    DeleteKey HKEY_CURRENT_USER, Evaluation_Information(i).ThePath
                ElseIf Evaluation_Information(i).TheRoot = "HKEY_LOCAL_MACHINE" Then
                    EnumAllRegKeys HKEY_LOCAL_MACHINE, Evaluation_Information(i).ThePath
                    For j = 1 To 3
                        DoEvents
                        For k = 1 To UBound(AllKeys)
                            DoEvents
                            DeleteKey HKEY_LOCAL_MACHINE, AllKeys(k)
                        Next k
                    Next j
                    
                    DeleteKey HKEY_LOCAL_MACHINE, Evaluation_Information(i).ThePath
                End If
                
                Erase AllKeys()
            End If
        End If
    Next i
End If
End Sub

Public Sub Protector_Obsidium(ByVal Action As WhatToDo)
On Error Resume Next

Dim TempPath As String
Dim TheFiles As String

If Action = PROTECTOR_SCAN Then
    ShowProgress "Scanning Obsidium"
    
    For i = 1 To UBound(SEARCH_OBSIDIUM)
        DoEvents
        
        Erase AllKeys()
        ReDim AllKeys(0) As String
        
        ShowProgress "Scanning " & SEARCH_OBSIDIUM(i)
        Select Case Left$(SEARCH_ASPROTECT(i), 4)
            Case Is = "HKCR"
                EnumKeys HKEY_CLASSES_ROOT, Mid$(SEARCH_OBSIDIUM(i), 6)
                ExtractValidKeys HKEY_CLASSES_ROOT, Obsidium, Mid$(SEARCH_OBSIDIUM(i), 6)
            Case Is = "HKCU"
                EnumKeys HKEY_CURRENT_USER, Mid$(SEARCH_OBSIDIUM(i), 6)
                ExtractValidKeys HKEY_CURRENT_USER, Obsidium, Mid$(SEARCH_OBSIDIUM(i), 6)
            Case Is = "HKLM"
                EnumKeys HKEY_LOCAL_MACHINE, Mid$(SEARCH_OBSIDIUM(i), 6)
                ExtractValidKeys HKEY_LOCAL_MACHINE, Obsidium, Mid$(SEARCH_OBSIDIUM(i), 6)
        End Select
    Next i
    
    Erase AllKeys()
    ReDim AllKeys(0) As String
    ShowProgress "Scanning HKCU\Software\Obsidium"
    EnumKeys HKEY_CURRENT_USER, "SOFTWARE\Obsidium"
    ExtractValidKeys HKEY_CURRENT_USER, Obsidium, "SOFTWARE\Obsidium"
    
    Erase AllKeys()
    
    TempPath = Trim(ReadValue(HKEY_CURRENT_USER, "Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders", "AppData"))
    If Right$(TempPath, 1) <> "\" Then TempPath = TempPath & "\"
    TempPath = TempPath & "Obsidium\"
    
    TheFiles = Dir$(TempPath & "*.*")
    Do Until Len(TheFiles) = 0
        DoEvents
        ShowProgress "Scanning " & TheFiles
        AddFoundKey "Obsidium", "File", "", TempPath & TheFiles
        TheFiles = Dir
    Loop
    
    ShowProgress "Idle"
ElseIf Action = PROTECTOR_REMOVE Then
    For i = 1 To UBound(Evaluation_Information)
        DoEvents
        If Evaluation_Information(i).ThePacker = "Obsidium" Then
            If Evaluation_Information(i).ToClear = True Then
                If Evaluation_Information(i).TheType = "Reg" Then
                    If Evaluation_Information(i).TheRoot = "HKEY_CLASSES_ROOT" Then
                        DeleteKey HKEY_CLASSES_ROOT, Evaluation_Information(i).ThePath & "\ProgID"
                        DeleteKey HKEY_CLASSES_ROOT, Evaluation_Information(i).ThePath & "\MiscStatus"
                        DeleteKey HKEY_CLASSES_ROOT, Evaluation_Information(i).ThePath & "\InProcServer32"
                        DeleteKey HKEY_CLASSES_ROOT, Evaluation_Information(i).ThePath & "\DataFormats\DefaultFile"
                        DeleteKey HKEY_CLASSES_ROOT, Evaluation_Information(i).ThePath & "\DataFormats\GetSet\0"
                        DeleteKey HKEY_CLASSES_ROOT, Evaluation_Information(i).ThePath & "\DataFormats\GetSet"
                        DeleteKey HKEY_CLASSES_ROOT, Evaluation_Information(i).ThePath & "\DataFormats"
                        DeleteKey HKEY_CLASSES_ROOT, Evaluation_Information(i).ThePath & "\Conversion\Readable\Main"
                        DeleteKey HKEY_CLASSES_ROOT, Evaluation_Information(i).ThePath & "\Conversion\Readable"
                        DeleteKey HKEY_CLASSES_ROOT, Evaluation_Information(i).ThePath & "\Conversion"
                        DeleteKey HKEY_CLASSES_ROOT, Evaluation_Information(i).ThePath & "\AuxUserType\2"
                        DeleteKey HKEY_CLASSES_ROOT, Evaluation_Information(i).ThePath & "\AuxUserType"
                        DeleteKey HKEY_CLASSES_ROOT, Evaluation_Information(i).ThePath
                    ElseIf Evaluation_Information(i).TheRoot = "HKEY_CURRENT_USER" Then
                        DeleteKey HKEY_CURRENT_USER, Evaluation_Information(i).ThePath
                    ElseIf Evaluation_Information(i).TheRoot = "HKEY_LOCAL_MACHINE" Then
                        DeleteKey HKEY_LOCAL_MACHINE, Evaluation_Information(i).ThePath
                    End If
                Else
                    SetAttr Evaluation_Information(i).ThePath, vbNormal
                    Kill Evaluation_Information(i).ThePath
                End If
            End If
        End If
    Next i
End If
End Sub

Public Sub Protector_PCGuard(ByVal Action As WhatToDo)
On Error Resume Next

Dim TheFiles As String

If Action = PROTECTOR_SCAN Then
    Erase AllKeys()
    ReDim AllKeys(0) As String
    ShowProgress "Scanning HKCR"
    EnumAllRegKeys HKEY_CLASSES_ROOT, ""
    ExtractValidKeys HKEY_CLASSES_ROOT, PCGuard, ""
    
    Erase AllKeys()
    ReDim AllKeys(0) As String
    ShowProgress "Scanning HKCU"
    EnumAllRegKeys HKEY_CURRENT_USER, ""
    ExtractValidKeys HKEY_CURRENT_USER, PCGuard, ""

    Erase AllKeys()
    ReDim AllKeys(0) As String
    ShowProgress "Scanning HKLM"
    EnumAllRegKeys HKEY_LOCAL_MACHINE, ""
    ExtractValidKeys HKEY_LOCAL_MACHINE, PCGuard, ""
    
    TheFiles = Dir$(Left$(DIR_WINDOWS, 3) & "*.*", vbHidden + vbSystem)
    Do Until Len(TheFiles) = 0
        DoEvents
        ShowProgress "Scanning " & TheFiles
        If Left$(TheFiles, 8) = "PCGWIN32" Then
            AddFoundKey "PCGuard", "File", "", Left$(DIR_WINDOWS, 3) & TheFiles
        End If
        TheFiles = Dir
    Loop
    
    TheFiles = Dir$(DIR_WINDOWS & "*.*", vbHidden + vbSystem)
    Do Until Len(TheFiles) = 0
        DoEvents
        ShowProgress "Scanning " & TheFiles
        If Left$(TheFiles, 8) = "PCGWIN32" Then
            AddFoundKey "PCGuard", "File", "", DIR_WINDOWS & TheFiles
        End If
        TheFiles = Dir
    Loop
    
    TheFiles = Dir$(DIR_SYSTEM & "*.*", vbHidden + vbSystem)
    Do Until Len(TheFiles) = 0
        DoEvents
        ShowProgress "Scanning " & TheFiles
        If Left$(TheFiles, 8) = "PCGWIN32" Then
            AddFoundKey "PCGuard", "File", "", DIR_SYSTEM & TheFiles
        End If
        TheFiles = Dir
    Loop
    
    ShowProgress "Idle"
ElseIf Action = PROTECTOR_REMOVE Then
    For i = 1 To UBound(Evaluation_Information)
        DoEvents
        If Evaluation_Information(i).ThePacker = "PCGuard" Then
            If Evaluation_Information(i).ToClear = True Then
                If Evaluation_Information(i).TheType = "Reg" Then
                    If Evaluation_Information(i).TheRoot = "HKEY_CLASSES_ROOT" Then
                        DeleteKey HKEY_CLASSES_ROOT, Evaluation_Information(i).ThePath
                    ElseIf Evaluation_Information(i).TheRoot = "HKEY_CURRENT_USER" Then
                        DeleteKey HKEY_CURRENT_USER, Evaluation_Information(i).ThePath
                    ElseIf Evaluation_Information(i).TheRoot = "HKEY_LOCAL_MACHINE" Then
                        DeleteKey HKEY_LOCAL_MACHINE, Evaluation_Information(i).ThePath
                    End If
                ElseIf Evaluation_Information(i).TheType = "File" Then
                    SetAttr Evaluation_Information(i).ThePath, vbNormal
                    Kill Evaluation_Information(i).ThePath
                End If
            End If
        End If
    Next i
End If
End Sub

Public Sub Protector_SVK(ByVal Action As WhatToDo)
On Error Resume Next

If Action = PROTECTOR_SCAN Then
    If ExistFile(DIR_SYSTEM & "is.dll") = True Then AddFoundKey "SVK", "File", "", DIR_SYSTEM & "is.dll"
    If ExistFile(DIR_SYSTEM & "aa.dll") = True Then AddFoundKey "SVK", "File", "", DIR_SYSTEM & "aa.dll"
ElseIf Action = PROTECTOR_REMOVE Then
    For i = 1 To UBound(Evaluation_Information)
        DoEvents
        If Evaluation_Information(i).ThePacker = "SVK" Then
            If Evaluation_Information(i).ToClear = True Then
                SetAttr Evaluation_Information(i).ThePath, vbNormal
                Kill Evaluation_Information(i).ThePath
            End If
        End If
    Next i
End If
End Sub
Public Sub AddFoundKey(ByVal ThePacker As String, ByVal TheType As String, ByVal TheRoot As String, ByVal ThePath As String)
ReDim Preserve Evaluation_Information(UBound(Evaluation_Information) + 1) As Listing
Evaluation_Information(UBound(Evaluation_Information)).ThePacker = ThePacker
Evaluation_Information(UBound(Evaluation_Information)).TheType = TheType
Evaluation_Information(UBound(Evaluation_Information)).TheRoot = TheRoot
Evaluation_Information(UBound(Evaluation_Information)).ThePath = ThePath
Evaluation_Information(UBound(Evaluation_Information)).ToClear = False
Evaluation_Information(UBound(Evaluation_Information)).BackUp = "No"
End Sub
Private Sub ExtractValidKeys(ByVal hKey As RegistryPaths, ByVal Packer As Packers, ByVal ThePath As String)
Dim TheValue    As String
Dim TheValue2   As String

For i = 1 To UBound(AllKeys)
    DoEvents
    
    If Packer = Armadillo Then
        EnumValues hKey, ThePath & "\" & AllKeys(i)
    
    ElseIf Packer = ASProtect Then
        TheValue = Trim(ReadValue(hKey, ThePath & "\" & AllKeys(i) & "\TypeLib", ""))
        TheValue2 = Trim(ReadValue(hKey, ThePath & "\" & AllKeys(i), ""))
        
        ASProtect_VERS = IIf(TheValue2 = "", False, True)
        
        If TheValue <> "" Then
            ASProtect_FLAG = True
            Erase AS_EnumKeys()
            ReDim AS_EnumKeys(0) As String
            EnumKeys hKey, "TypeLib\" & TheValue
            
            If UBound(AS_EnumKeys) = 0 Then
                If hKey = HKEY_CLASSES_ROOT Then
                    AddFoundKey "ASProtect", "Reg", "HKEY_CLASSES_ROOT", ThePath & "\" & AllKeys(i)
                    AddFoundKey "ASProtect", "Reg", "HKEY_CLASSES_ROOT", "TypeLib\" & TheValue
                ElseIf hKey = HKEY_CURRENT_USER Then
                    AddFoundKey "ASProtect", "Reg", "HKEY_CURRENT_USER", ThePath & "\" & AllKeys(i)
                    AddFoundKey "ASProtect", "Reg", "HKEY_CURRENT_USER", "TypeLib\" & TheValue
                ElseIf hKey = HKEY_LOCAL_MACHINE Then
                    AddFoundKey "ASProtect", "Reg", "HKEY_LOCAL_MACHINE", ThePath & "\" & AllKeys(i)
                    AddFoundKey "ASProtect", "Reg", "HKEY_LOCAL_MACHINE", "TypeLib\" & TheValue
                End If
                
                ASProtect_FLAG = False
                Erase AS_EnumKeys()
            End If
        End If
    
    ElseIf Packer = Obsidium Then
        If (hKey = HKEY_CURRENT_USER) And (ThePath = "SOFTWARE\Obsidium") Then
            AddFoundKey "Obsidium", "Reg", "HKEY_CURRENT_USER", "SOFTWARE\Obsidium\" & AllKeys(i)
        Else
            TheValue = Trim(ReadValue(HKEY_CLASSES_ROOT, ThePath & "\" & AllKeys(i), ""))
            If TheValue = "Picture (Metafile)" Then
                TheValue = Trim(ReadValue(HKEY_CLASSES_ROOT, ThePath & "\" & AllKeys(i), "AppID"))
                If TheValue <> "" Then
                    If hKey = HKEY_CLASSES_ROOT Then
                        AddFoundKey "Obsidium", "Reg", "HKEY_CLASSES_ROOT", ThePath & "\" & AllKeys(i)
                    ElseIf hKey = HKEY_CURRENT_USER Then
                        AddFoundKey "Obsidium", "Reg", "HKEY_CURRENT_USER", ThePath & "\" & AllKeys(i)
                    ElseIf hKey = HKEY_LOCAL_MACHINE Then
                        AddFoundKey "Obsidium", "Reg", "HKEY_LOCAL_MACHINE", ThePath & "\" & AllKeys(i)
                    End If
                End If
            End If
        End If
    
    ElseIf Packer = PCGuard Then
        TheValue = Trim(ReadValue(hKey, AllKeys(i), Chr$(32)))
        If TheValue <> "" Then
            If hKey = HKEY_CLASSES_ROOT Then
                AddFoundKey "PCGuard", "Reg", "HKEY_CLASSES_ROOT", AllKeys(i)
            ElseIf hKey = HKEY_CURRENT_USER Then
                AddFoundKey "PCGuard", "Reg", "HKEY_CURRENT_USER", AllKeys(i)
            ElseIf hKey = HKEY_LOCAL_MACHINE Then
                AddFoundKey "PCGuard", "Reg", "HKEY_LOCAL_MACHINE", AllKeys(i)
            End If
        End If
    End If
Next i
End Sub
