Attribute VB_Name = "RegistryModule"
Public Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Public Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Public Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, lpcbName As Long, lpReserved As Long, ByVal lpClass As String, lpcbClass As Long, lpftLastWriteTime As FILETIME) As Long
Public Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Public Declare Function RegEnumKey Lib "advapi32.dll" Alias "RegEnumKeyA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, ByVal cbName As Long) As Long
Public Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Public Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, lpData As Byte, lpcbData As Long) As Long
Public Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
Public Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Public Enum ValueTypes
    REG_NONE = 0
    REG_SZ = 1
    REG_EXPAND_SZ = 2
    REG_BINARY = 3
    REG_DWORD = 4
    REG_DWORD_LITTLE_ENDIAN = 4
    REG_DWORD_BIG_ENDIAN = 5
    REG_LINK = 6
    REG_MULTI_SZ = 7
    REG_RESOURCE_LIST = 8
End Enum

Public Enum RegistryPaths
    HKEY_CLASSES_ROOT = &H80000000
    HKEY_CURRENT_USER = &H80000001
    HKEY_LOCAL_MACHINE = &H80000002
End Enum

Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type
    
Public Const KEY_ENUMERATE_SUB_KEYS = &H8
Public Const KEY_READ = &H20019
Public Const ERROR_SUCCESS = 0&
Public Const KEY_QUERY_VALUE = &H1
Public Const KEY_ALL_ACCESS = &HF003F
Public Const KEY_WRITE = &H20006

Dim ReturnValue As Long

Public Function EnumKeys(ByVal hKey As RegistryPaths, ByVal SubKey As String)
Dim Temp        As Long
Dim KeyName     As String
Dim KeyLen      As Long
Dim ClassName   As String
Dim ClassLen    As Long
Dim LastWrite   As FILETIME
Dim Index       As Long
Dim FoundPath   As String
    
ReturnValue = RegOpenKeyEx(hKey, SubKey, 0, KEY_ENUMERATE_SUB_KEYS, Temp)

If ASProtect_VERS = True Then
    If ReturnValue <> 0 Then
        ReDim Preserve AS_EnumKeys(UBound(AS_EnumKeys) + 1) As String
        AS_EnumKeys(UBound(AS_EnumKeys)) = ""
        Exit Function
    End If
End If

Index = 0
While ReturnValue = 0
    KeyName = Space(255)
    ClassName = Space(255)
    KeyLen = 255
    ClassLen = 255

    ReturnValue = RegEnumKeyEx(Temp, Index, KeyName, KeyLen, ByVal 0, ClassName, ClassLen, LastWrite)
      
    If ReturnValue = 0 Then
        KeyName = Left(KeyName, KeyLen)
        ClassName = Left(ClassName, ClassLen)
        FoundPath = KeyName
        
        If ASProtect_FLAG = True Then
            ReDim Preserve AS_EnumKeys(UBound(AS_EnumKeys) + 1) As String
            AS_EnumKeys(UBound(AS_EnumKeys)) = FoundPath
        Else
            ReDim Preserve AllKeys(UBound(AllKeys) + 1) As String
            AllKeys(UBound(AllKeys)) = FoundPath
        End If
    End If
    Index = Index + 1
Wend
ReturnValue = RegCloseKey(Temp)
End Function
Public Function ReadValue(ByVal hKey As RegistryPaths, ByVal SubKey As String, ByVal ValueName As String)
Dim Temp        As Long
Dim FoundValue  As String
Dim ValueSize   As Long
Dim DataType    As Long
Dim ValueData   As String
Dim TempValue   As String

ReturnValue = RegOpenKeyEx(hKey, SubKey, 0, KEY_READ, Temp)

If ReturnValue = 0 Then
    FoundValue = Space$(2048)
    ValueSize = 2048
    ReturnValue = RegQueryValueEx(Temp, ValueName, 0, DataType, ByVal FoundValue, ValueSize)
    FoundValue = Left$(FoundValue, ValueSize - 1)
    
    ValueData = ""
    ValueData = FoundValue
    
    ReturnValue = RegCloseKey(Temp)
    ReadValue = ValueData
End If
End Function
Public Function DeleteKey(ByVal hKey As RegistryPaths, ByVal SubKey As String)
ReturnValue = RegDeleteKey(hKey, SubKey)
End Function
Public Sub EnumAllRegKeys(ByVal hKey As RegistryPaths, ByVal SubKey As String)
'###########################################################
'####              This function was written            ####
'####                                                   ####
'####       by Arkadiy Olovyannikov (ark@fesma.ru)      ####
'####                                                   ####
'###########################################################
On Error GoTo Er

Dim Temp    As Long
Dim Index   As Long
Dim KeyName As String
Dim TempKey As String

If RegOpenKeyEx(hKey, SubKey, 0, KEY_READ, Temp) Then Exit Sub

Do
    DoEvents
    KeyName = Space$(255)
    If RegEnumKey(Temp, Index, KeyName, 255) <> ERROR_SUCCESS Then Exit Do
    Index = Index + 1
    KeyName = TrimNull(KeyName)
    If SubKey <> "" Then
        TempKey = SubKey & "\" & KeyName
    Else
        TempKey = KeyName
    End If
    
    ReDim Preserve AllKeys(UBound(AllKeys) + 1) As String
    AllKeys(UBound(AllKeys)) = TempKey
    
    Call EnumAllRegKeys(hKey, TempKey)
Loop
Er:
RegCloseKey Temp
End Sub
Public Function TrimNull(StartStr As String) As String
   Dim pos As Integer
   pos = InStr(StartStr, Chr$(0))
   If pos Then
      TrimNull = Left$(StartStr, pos - 1)
      Exit Function
   End If
   TrimNull = StartStr
End Function
Public Function EnumValues(ByVal hKey As RegistryPaths, ByVal SubKey As String)
Dim Index           As Long
Dim ValueName       As String
Dim ValueLen        As Long
Dim DataLen         As Long
Dim DataType        As Long
Dim Data(0 To 254)  As Byte
Dim FoundValueName  As String
Dim FoundValueData  As String
Dim TempValue       As String

Dim Lister  As ListItem
Dim Alrd    As Boolean
Dim MyFlag  As Boolean

Alrd = False

ReturnValue = RegOpenKeyEx(hKey, SubKey, 0, KEY_QUERY_VALUE, Temp)

Index = 0
While ReturnValue = 0
    ValueName = Space$(255)
    ValueLen = 255
    DataLen = 255
    
    ReturnValue = RegEnumValue(Temp, Index, ValueName, ValueLen, ByVal 0, DataType, Data(0), DataLen)
    
    If ReturnValue = 0 Then
        ValueName = Left$(ValueName, ValueLen)
        FoundValueName = ValueName
        
        FoundValueData = ""
        
        If (DataType = REG_BINARY) Or (DataType = REG_DWORD) Or (DataType = REG_DWORD_LITTLE_ENDIAN) Or (DataType = REG_DWORD_BIG_ENDIAN) Then
            For i = 0 To DataLen - 1
                DoEvents
                TempValue = Hex$(Data(i))
                If Len(TempValue) = 1 Then TempValue = "0" & TempValue
                FoundValueData = FoundValueData & TempValue
            Next i
        Else
            FoundValueData = Space$(DataLen - 1)
            CopyMemory ByVal FoundValueData, Data(0), DataLen - 1
        End If
        
        'armadillo routine
        If ARM_FLAG = False Then
            MyFlag = False
            For i = 1 To UBound(EXL_ARMADILLO)
                DoEvents
                If UCase$(EXL_ARMADILLO(i)) = UCase$(FoundValueName) Then
                    MyFlag = True
                    Exit For
                End If
            Next i
            
            If (FoundValueName <> "0") And (Len(FoundValueData) <= 32) Then MyFlag = True
            If InStr(1, FoundValueData, ".dll", vbTextCompare) > 0 Then MyFlag = True
            
            If MyFlag = False Then
                If Alrd = False Then
                    If hKey = HKEY_CLASSES_ROOT Then
                        AddFoundKey "Armadillo", "Reg", "HKEY_CLASSES_ROOT", SubKey
                    ElseIf hKey = HKEY_CURRENT_USER Then
                        AddFoundKey "Armadillo", "Reg", "HKEY_CURRENT_USER", SubKey
                    ElseIf hKey = HKEY_LOCAL_MACHINE Then
                        AddFoundKey "Armadillo", "Reg", "HKEY_LOCAL_MACHINE", SubKey
                    End If
                    Alrd = True
                End If
            End If
        Else
            'enum values for listview
            MyFlag = False
            For i = 1 To UBound(EXL_ARMADILLO)
                DoEvents
                If UCase$(EXL_ARMADILLO(i)) = UCase$(FoundValueName) Then
                    MyFlag = True
                    Exit For
                End If
            Next i
            
            If (FoundValueName <> "0") And (Len(FoundValueData) <= 32) Then MyFlag = True
            If InStr(1, FoundValueData, ".dll", vbTextCompare) > 0 Then MyFlag = True
            
            If MyFlag = False Then

                Set Lister = Main.ListView1.ListItems.Add()
            
                Lister.Text = FoundValueName
                Lister.SubItems(1) = FoundValueData
            
                If (DataType = REG_BINARY) Or (DataType = REG_DWORD) Or (DataType = REG_DWORD_LITTLE_ENDIAN) Or (DataType = REG_DWORD_BIG_ENDIAN) Then
                    Lister.SmallIcon = 14
                        
                    If FoundValueName = "0" Then
                        Lister.SubItems(2) = "100%"
                    ElseIf Left$(FoundValueData, 4) = "729A" Then
                        Lister.SubItems(2) = "100%"
                    End If
                Else
                    Lister.SmallIcon = 15
                    
                    If IsText(FoundValueData) = False Then Lister.SubItems(2) = "90%"
                End If
                
                If Lister.SubItems(2) = "" Then Lister.SubItems(2) = "50%"
                
                For i = 1 To UBound(Evaluation_Information)
                    DoEvents
                    If FoundValueName = Evaluation_Information(i).ArmValue Then Lister.Checked = True
                Next i
            End If
        End If
    End If

    Index = Index + 1
Wend

ReturnValue = RegCloseKey(Temp)
End Function
Public Function DeleteValues(ByVal hKey As RegistryPaths, ByVal SubKey As String)
Dim Index           As Long
Dim ValueName       As String
Dim ValueLen        As Long
Dim DataLen         As Long
Dim DataType        As Long
Dim Data(0 To 254)  As Byte
Dim FoundValueName  As String
Dim FoundValueData  As String
Dim TempValue       As String

ReturnValue = RegOpenKeyEx(hKey, SubKey, 0, KEY_QUERY_VALUE, Temp)

Index = 0
While ReturnValue = 0
    ValueName = Space$(255)
    ValueLen = 255
    DataLen = 255
    
    ReturnValue = RegEnumValue(Temp, Index, ValueName, ValueLen, ByVal 0, DataType, Data(0), DataLen)
    
    If ReturnValue = 0 Then
        ValueName = Left$(ValueName, ValueLen)
        
        DeleteValue hKey, SubKey, ValueName
    End If

    Index = Index + 1
Wend

ReturnValue = RegCloseKey(Temp)
End Function
Public Function DeleteValue(ByVal hKey As RegistryPaths, ByVal SubKey As String, ByVal ValueName As String)
Dim ReturnValue As Long
Dim Temp        As Long

ReturnValue = RegOpenKeyEx(hKey, SubKey, 0, KEY_WRITE, Temp)

If ReturnValue = 0 Then
    ReturnValue = RegDeleteValue(Temp, ValueName)
    ReturnValue = RegCloseKey(Temp)
End If
End Function


